// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
// Copyright (c) 2005 Novell, Inc.
//
// Authors:
//	Jordi Mas i Hernandez, jordi@ximian.com
//
//
// A single ComboBox with many items and easy to change between modes
//

using System;
using System.Drawing;
using System.Windows.Forms;

namespace MyFormProject 
{
	class MainForm : Form
	{
		private Label label;
		private ComboBox comboBox;
		private Button buttonSimple;
		private Button buttonDropDown;
		private Button buttonDropDownList;
		private Button buttonAddItems;
		private Button buttonCleanItems;
		private Button buttonDropDownAction;
		private NumericUpDown updownDropDownHeight;
		private ComboBox comboFlatStyle;
		private ComboBox comboDrawMode;
		private int last_item = 0;

		public MainForm()
		{
			InitializeComponent();
		}
	
		void InitializeComponent() 
		{
			comboBox = new ComboBox ();			
			this.SuspendLayout();
			// 
			// comboBox
			// 
			this.comboBox.Items.AddRange (new object[]
			{
				"Abella de la Conca             ",
				"Abrera                         ",
				"Agramunt                       ",
				"Aguilar de Segarra             ",
				"Agullana                       ",
				"Aiguafreda                     ",
				"Aiguamrcia                    ",
				"Aiguaviva                      ",
				"Aitona                         ",
				"Alams                         ",
				"Albags                        ",
				"Albany                        ",
				"Albatrrec                     ",
				"Albesa                         ",
				"Albi                           ",
				"Albinyana                      ",
				"Albiol                         ",
				"Albons                         ",
				"Alcanar                        ",
				"Alcan                         ",
				"Alcarrs                       ",
				"Alcoletge                      ",
				"Alcover                        ",
				"Aldea                          ",
				"Aldover                        ",
				"Aleixar                        ",
				"Alella                         ",
				"Alfara de Carles               ",
				"Alfarrs                       ",
				"Alfs                          ",
				"Alforja                        ",
				"Algerri                        ",
				"Alguaire                       ",
				"Alins                          ",
				"Ali                           ",
				"Almacelles                     ",
				"Almatret                       ",
				"Almenar                        ",
				"Almoster                       ",
				"Alp                            ",
				"Alpens                         ",
				"Alpicat                        ",
				"Alt neu                       ",
				"Altafulla                      ",
				"Als i Cerc                    ",
				"Als de Balaguer               ",
				"Amer                           ",
				"Ametlla de Mar                 ",
				"Ametlla del Valls             ",
				"Ampolla                        ",
				"Amposta                        ",
				"Anglesola                      ",
				"Angls                         ",
				"Arbeca                         ",
				"Arbol                         ",
				"Arbo                          ",
				"Arbcies                       ",
				"Arenys de Mar                  ",
				"Arenys de Munt                 ",
				"Argelaguer                     ",
				"Argentera                      ",
				"Argentona                      ",
				"Argenola                      ",
				"Armentera                      ",
				"Arnes                          ",
				"Arres                          ",
				"Arsguel                       ",
				"Artesa de Lleida               ",
				"Artesa de Segre                ",
				"Arts                          ",
				"Asc                           ",
				"Aspa                           ",
				"Avellanes i Santa Linya        ",
				"Avinyonet de Puigvents        ",
				"Avinyonet del Peneds          ",
				"Aviny                         ",
				"Avi                           ",
				"Badalona                       ",
				"Badia del Valls               ",
				"Bag                           ",
				"Baix Pallars                   ",
				"Balaguer                       ",
				"Baleny                        ",
				"Balsareny                      ",
				"Banyeres del Peneds           ",
				"Banyoles                       ",
				"Barbens                        ",
				"Barber de la Conca            ",
				"Barber del Valls             ",
				"Barcelona                      ",
				"Baronia de Rialb               ",
				"Bscara                        ",
				"Bassella                       ",
				"Batea                          ",
				"Bausen                         ",
				"Begues                         ",
				"Begur                          ",
				"Belianes                       ",
				"Bell-lloc d'Urgell             ",
				"Bellaguarda                    ",
				"Bellcaire d'Empord            ",
				"Bellcaire d'Urgell             ",
				"Bellmunt d'Urgell              ",
				"Bellmunt del Priorat           ",
				"Bellprat                       ",
				"Bellpuig                       ",
				"Bellvei                        ",
				"Bellver de Cerdanya            ",
				"Bellvs                        ",
				"Benavent de Segri             ",
				"Benifallet                     ",
				"Benissanet                     ",
				"Berga                          ",
				"Besal                         ",
				"Bescan                        ",
				"Beuda                          ",
				"Bigues i Riells                ",
				"Biosca                         ",
				"Bisbal d'Empord               ",
				"Bisbal de Falset               ",
				"Bisbal del Peneds             ",
				"Biure                          ",
				"Blancafort                     ",
				"Blanes                         ",
				"Boadella d'Empord             ",
				"Bolvir                         ",
				"Bonastre                       ",
				"Bordils                        ",
				"Borges Blanques                ",
				"Borges del Camp                ",
				"Borrass                       ",
				"Borred                        ",
				"Bossst                        ",
				"Bot                            ",
				"Botarell                       ",
				"Bovera                         ",
				"Breda                          ",
				"Bruc                           ",
				"Brull                          ",
				"Brunyola                       ",
				"Brfim                         ",
				"Bscara                        ",
				"Cabacs                        ",
				"Cabanabona                     ",
				"Cabanelles                     ",
				"Cabanes                        ",
				"Cabanyes                       ",
				"Cab                           ",
				"Cabra del Camp                 ",
				"Cabrera d'Igualada             ",
				"Cabrera de Mar                 ",
				"Cabrils                        ",
				"Cadaqus                       ",
				"Calaf                          ",
				"Calafell                       ",
				"Calders                        ",
				"Caldes d'Estrac                ",
				"Caldes de Malavella            ",
				"Caldes de Montbui              ",
				"Calella                        ",
				"Calldetenes                    ",
				"Calls                         ",
				"Calonge                        ",
				"Calonge de Segarra             ",
				"Camarasa                       ",
				"Camarles                       ",
				"Cambrils                       ",
				"Cams                          ",
				"Campdevnol                    ",
				"Campelles                      ",
				"Campins                        ",
				"Campllong                      ",
				"Camprodon                      ",
				"Canejan                        ",
				"Canet d'Adri                   ",
				"Canet de Mar                   ",
				"Canovelles                     ",
				"Cantallops                     ",
				"Canyelles                      ",
				"Capafonts                      ",
				"Capellades                     ",
				"Capmany                        ",
				"Capolat                        ",
				"Capanes                       ",
				"Cardedeu                       ",
				"Cardona                        ",
				"Carme                          ",
				"Caseres                        ",
				"Casserres                      ",
				"Cass de la Selva              ",
				"Castell de Mur                 ",
				"Castell de l'Areny             ",
				"Castell-Platja d'Aro           ",
				"Castellar de la Ribera         ",
				"Castellar de n'Hug             ",
				"Castellar del Riu              ",
				"Castellar del Valls           ",
				"Castellbell i el Vilar         ",
				"Castellbisbal                  ",
				"Castellcir                     ",
				"Castelldans                    ",
				"Castelldefels                  ",
				"Castellet i la Gornal          ",
				"Castellfollit de Riubregs     ",
				"Castellfollit de la Roca       ",
				"Castellfollit del Boix         ",
				"Castellgal                    ",
				"Castellnou de Bages            ",
				"Castellnou de Seana            ",
				"Castellol                     ",
				"Castell d'Empries            ",
				"Castell de Farfanya           ",
				"Castellser                    ",
				"Castellterol                  ",
				"Castellvell del Camp           ",
				"Castellv de Rosanes           ",
				"Castellv de la Marca          ",
				"Catllar                        ",
				"Cava                           ",
				"Cellera de Ter                 ",
				"Celr                          ",
				"Centelles                      ",
				"Cercs                          ",
				"Cerdanyola del Valls          ",
				"Cervell                       ",
				"Cervera                        ",
				"Cervi de Ter                  ",
				"Cervi de les Garrigues        ",
				"Cistella                       ",
				"Ciutadilla                     ",
				"Clariana de Cardener           ",
				"Cogul                          ",
				"Colera                         ",
				"Coll de Narg                  ",
				"Collbat                       ",
				"Colldejou                      ",
				"Collsuspina                    ",
				"Colomers                       ",
				"Coma i la Pedra                ",
				"Conca de Dalt			",
				"Conesa                         ",
				"Constant                      ",
				"Copons                         ",
				"Corbera d'Ebre                 ",
				"Corbera de Llobregat           ",
				"Corbins                        ",
				"Cornell de Llobregat          ",
				"Cornell del Terri             ",
				"Cornudella de Montsant         ",
				"Cor                          ",
				"Creixell                       ",
				"Crespi                        ",
				"Crulles,Monells i Sant Sadur. ",
				"Cubelles                       ",
				"Cubells                        ",
				"Cunit                          ",
				"Cnoves i Samals              ",
				"Darnius                        ",
				"Das                            ",
				"Deltebre                       ",
				"Dosrius                        ",
				"Duesaiges                     ",
				"Es Brdes                      ",
				"Escala                         ",
				"Esparreguera                   ",
				"Espinelves                     ",
				"Espluga Calba                  ",
				"Espluga de Francol            ",
				"Esplugues de Llobregat         ",
				"Espolla                        ",
				"Esponell                      ",
				"Espot                          ",
				"Espunyola                      ",
				"Estamariu                      ",
				"Estany                         ",
				"Estars                        ",
				"Esterri d'neu                 ",
				"Esterri de Cards              ",
				"Falset                         ",
				"Far d'Empord                  ",
				"Farrera                        ",
				"Fatarella                      ",
				"Febr                          ",
				"Figar-Montmany                ",
				"Figuera                        ",
				"Figueres                       ",
				"Figuerola del Camp             ",
				"Fgols                         ",
				"Fgols i Aliny                ",
				"Fla                          ",
				"Flix                           ",
				"Floresta                       ",
				"Fogars de Montcls             ",
				"Fogars de la Selva             ",
				"Foix                          ",
				"Folgueroles                    ",
				"Fondarella                     ",
				"Fonollosa                      ",
				"Font-rub                      ",
				"Fontanals de Cerdanya          ",
				"Fontanilles                    ",
				"Fontcoberta                    ",
				"Foradada                       ",
				"Forallac                       ",
				"Fornells de la Selva           ",
				"Forti                         ",
				"Fors                          ",
				"Franqueses del Valls          ",
				"Freginals                      ",
				"Fuliola                        ",
				"Fulleda                        ",
				"Gai                           ",
				"Galera                         ",
				"Gallifa                        ",
				"Gandesa                        ",
				"Garcia                         ",
				"Garidells                      ",
				"Garriga                        ",
				"Garrigoles                     ",
				"Garriguella                    ",
				"Garrigs                       ",
				"Gavet de la Conca              ",
				"Gav                           ",
				"Gelida                         ",
				"Ger                            ",
				"Gimenells i el Pla de la Font  ",
				"Ginestar                       ",
				"Girona                         ",
				"Gironella                      ",
				"Gisclareny                     ",
				"Godall                         ",
				"Golms                         ",
				"Gombrn                        ",
				"Gsol                          ",
				"Granada                        ",
				"Granadella                     ",
				"Granera                        ",
				"Granja d'Escarp                ",
				"Granollers                     ",
				"Granyanella                    ",
				"Granyena de Segarra            ",
				"Granyena de les Garrigues      ",
				"Gratallops                     ",
				"Gualba                         ",
				"Gualta                         ",
				"Guardiola de Bergued          ",
				"Guiamets                       ",
				"Guils de Cerdanya              ",
				"Guimer                        ",
				"Guingueta d'neu               ",
				"Guissona                       ",
				"Guixers                        ",
				"Gurb                           ",
				"Horta de Sant Joan             ",
				"Hospitalet de Llobregat        ",
				"Hostalets de Pierola           ",
				"Hostalric                      ",
				"Igualada                       ",
				"Isona i Conca Dell            ",
				"Isvol                         ",
				"Ivars d'Urgell                 ",
				"Ivars de Noguera               ",
				"Ivorra                         ",
				"Jafre                          ",
				"Jonquera                       ",
				"Jorba                          ",
				"Josa i Tuixn                  ",
				"Jui                           ",
				"Juncosa                        ",
				"Juneda                         ",
				"Les                            ",
				"Linyola                        ",
				"Llacuna                        ",
				"Lladorre                       ",
				"Llad                          ",
				"Lladurs                        ",
				"Llagosta                       ",
				"Llagostera                     ",
				"Llambilles                     ",
				"Llanars                        ",
				"Llan                         ",
				"Llardecans                     ",
				"Llavors                       ",
				"Lleida                         ",
				"Llers                          ",
				"Lles                           ",
				"Llimiana                       ",
				"Llinars del Valls             ",
				"Lli d'Amunt                  ",
				"Lli de Vall                  ",
				"Llvia                         ",
				"Lloar                          ",
				"Llobera                        ",
				"Llorac                         ",
				"Lloren del Peneds            ",
				"Lloret de Mar                  ",
				"Llosses                        ",
				"Llu                          ",
				"Madremanya                     ",
				"Maials                         ",
				"Mai de Montcal                ",
				"Mald                          ",
				"Malgrat de Mar                 ",
				"Malla                          ",
				"Manlleu                        ",
				"Manresa                        ",
				"Margalef                       ",
				"Marganell                      ",
				"Martorell                      ",
				"Martorelles                    ",
				"Mar                          ",
				"Mas de Barberans               ",
				"Masarac                        ",
				"Masdenverge                    ",
				"Masies de Roda                 ",
				"Masies de Voltreg             ",
				"Maslloren                     ",
				"Masnou                         ",
				"Mas                           ",
				"Maspujols                      ",
				"Masquefa                       ",
				"Masroig                        ",
				"Massalcoreig                   ",
				"Massanes                       ",
				"Massoteres                     ",
				"Matadepera                     ",
				"Matar                         ",
				"Maanet de Cabrenys            ",
				"Maanet de la Selva            ",
				"Mediona                        ",
				"Menrguens                     ",
				"Meranges                       ",
				"Mieres                         ",
				"Mil                           ",
				"Miralcamp                      ",
				"Miravet                        ",
				"Moi                           ",
				"Molar                          ",
				"Molins de Rei                  ",
				"Mollerussa                     ",
				"Mollet de Peralada             ",
				"Mollet del Valls              ",
				"Moll                          ",
				"Molsosa                        ",
				"Monistrol de Calders           ",
				"Monistrol de Montserrat        ",
				"Mont-ral                       ",
				"Mont-ras                       ",
				"Mont-roig del Camp             ",
				"Montagut                       ",
				"Montblanc                      ",
				"Montbri del Camp              ",
				"Montcada i Reixac              ",
				"Montclar                       ",
				"Montell i Martinet            ",
				"Montesquiu                     ",
				"Montferrer i Castellb         ",
				"Montferri                      ",
				"Montgai                        ",
				"Montgat                        ",
				"Montmajor                      ",
				"Montmaneu                      ",
				"Montmell                       ",
				"Montmel                       ",
				"Montoliu de Lleida             ",
				"Montoliu de Segarra            ",
				"Montorns de Segarra           ",
				"Montorns del Valls           ",
				"Montseny                       ",
				"Morell                         ",
				"Morera de Montsant             ",
				"Mra d'Ebre                    ",
				"Mra la Nova                   ",
				"Muntanyola                     ",
				"Mura                           ",
				"Nalec                          ",
				"Naut Aran                      ",
				"Navarcles                      ",
				"Navata                         ",
				"Navs                          ",
				"Navs                          ",
				"Nou de Bergued                ",
				"Nou de Gai                    ",
				"Nulles                         ",
				"Odn                           ",
				"Ogassa                         ",
				"Olesa de Bonesvalls            ",
				"Olesa de Montserrat            ",
				"Oliana                         ",
				"Oliola                         ",
				"Olius                          ",
				"Olivella                       ",
				"Olost                          ",
				"Olot                           ",
				"Oluges                         ",
				"Olvan                          ",
				"Olrdola                       ",
				"Omellons                       ",
				"Omells de na Gaia              ",
				"Ordis                          ",
				"Organy                        ",
				"Orist                         ",
				"Ors                           ",
				"Orp                           ",
				"Os de Balaguer                 ",
				"Osor                           ",
				"Oss de Si                    ",
				"Pacs del Peneds               ",
				"Palafolls                      ",
				"Palafrugell                    ",
				"Palams                        ",
				"Palau d'Anglesola              ",
				"Palau de Plegamans             ",
				"Palau de Santa Eullia         ",
				"Palau-sator                    ",
				"Palau-saverdera                ",
				"Pallaresos                     ",
				"Pallej                        ",
				"Palma d'Ebre                   ",
				"Palma de Cervell              ",
				"Palol de Revardit              ",
				"Pals                           ",
				"Papiol                         ",
				"Pardines                       ",
				"Parets del Valls              ",
				"Parlav                        ",
				"Passanant                      ",
				"Pau                            ",
				"Pals                          ",
				"Pedret i Marz                 ",
				"Penelles                       ",
				"Pera                           ",
				"Perafita                       ",
				"Perafort                       ",
				"Peralada                       ",
				"Peramola                       ",
				"Perell                        ",
				"Piera                          ",
				"Piles                          ",
				"Pineda de Mar                  ",
				"Pinell de Brai                 ",
				"Pinell de Solsons             ",
				"Pins                          ",
				"Pira                           ",
				"Pla de Santa Maria             ",
				"Pla del Peneds                ",
				"Planes d'Hostoles              ",
				"Planoles                       ",
				"Plans de Si                   ",
				"Poal                           ",
				"Pobla de Crvoles              ",
				"Pobla de Claramunt             ",
				"Pobla de Lillet                ",
				"Pobla de Mafumet               ",
				"Pobla de Massaluca             ",
				"Pobla de Montorns             ",
				"Pobla de Segur                 ",
				"Poboleda                       ",
				"Poliny                        ",
				"Pont d'Armentera               ",
				"Pont de Bar                    ",
				"Pont de Molins                 ",
				"Pont de Suert                  ",
				"Pont de Vilomara i Rocafort    ",
				"Pontons                        ",
				"Pontils                        ",
				"Ponts                         ",
				"Ponts                          ",
				"Porqueres                      ",
				"Porrera                        ",
				"Port de la Selva               ",
				"Portbou                        ",
				"Portella                       ",
				"Pradell de la Teixeta          ",
				"Prades                         ",
				"Prat de Comte                  ",
				"Prat de Llobregat              ",
				"Pratdip                        ",
				"Prats de Lluans              ",
				"Prats de Rei                   ",
				"Prats i Sansor                 ",
				"Preixana                       ",
				"Preixens                       ",
				"Premi de Dalt                 ",
				"Premi de Mar                  ",
				"Preses                         ",
				"Prullans                       ",
				"Puig-reig                      ",
				"Puigcerd                      ",
				"Puigdlber                     ",
				"Puiggrs                       ",
				"Puigpelat                      ",
				"Puigverd d'Agramunt            ",
				"Puigverd de Lleida             ",
				"Pujalt                         ",
				"Quar                           ",
				"Quart                          ",
				"Queralbs                       ",
				"Querol                         ",
				"Rabs                          ",
				"Rajadell                       ",
				"Rasquera                       ",
				"Regencs                       ",
				"Rellinars                      ",
				"Renau                          ",
				"Reus                           ",
				"Rialp                          ",
				"Riba                           ",
				"Riba-roja d'Ebre               ",
				"Ribera d'Ondara                ",
				"Ribera d'Urgellet              ",
				"Ribes de Freser                ",
				"Riells i Viabrea               ",
				"Riera de Gai                  ",
				"Riner                          ",
				"Ripoll                         ",
				"Ripollet                       ",
				"Riu de Cerdanya                ",
				"Riudarenes                     ",
				"Riudaura                       ",
				"Riudecanyes                    ",
				"Riudecols                      ",
				"Riudellots de la Selva         ",
				"Riudoms                        ",
				"Riumors                        ",
				"Roca del Valls                ",
				"Rocafort de Queralt            ",
				"Roda de Bar                   ",
				"Roda de Ter                    ",
				"Rodony                        ",
				"Roquetes                       ",
				"Roses                          ",
				"Rossell                       ",
				"Rourell                        ",
				"Rubi                          ",
				"Rub                           ",
				"Rupit i Pruit                  ",
				"Rupi                          ",
				"Sabadell                       ",
				"Sags                          ",
				"Saldes                         ",
				"Sales de Llierca               ",
				"Sallent                        ",
				"Salom                         ",
				"Salou                          ",
				"Salt                           ",
				"Sals de Pallars               ",
				"Sanaja                        ",
				"Sant Adri de Bess            ",
				"Sant Agust de Lluans        ",
				"Sant Andreu Salou              ",
				"Sant Andreu de Llavaneres      ",
				"Sant Andreu de la Barca        ",
				"Sant Aniol de Finestres        ",
				"Sant Antoni de Vilamajor       ",
				"Sant Bartomeu del Grau         ",
				"Sant Boi de Llobregat          ",
				"Sant Boi de Lluans           ",
				"Sant Carles de la Rpita       ",
				"Sant Cebri de Vallalta        ",
				"Sant Celoni                    ",
				"Sant Climent Sescebes          ",
				"Sant Climent de Llobregat      ",
				"Sant Cugat Sesgarrigues        ",
				"Sant Cugat del Valls          ",
				"Sant Esteve Sesrovires         ",
				"Sant Esteve de Palautordera    ",
				"Sant Esteve de la Sarga        ",
				"Sant Feliu Sasserra            ",
				"Sant Feliu de Buixalleu        ",
				"Sant Feliu de Codines          ",
				"Sant Feliu de Guxols          ",
				"Sant Feliu de Llobregat        ",
				"Sant Feliu de Pallerols        ",
				"Sant Ferriol                   ",
				"Sant Fost de Campsentelles     ",
				"Sant Fruits de Bages          ",
				"Sant Gregori                   ",
				"Sant Guim de Freixenet         ",
				"Sant Guim de la Plana          ",
				"Sant Hilari Sacalm             ",
				"Sant Hiplit de Voltreg       ",
				"Sant Iscle de Vallalta         ",
				"Sant Jaume d'Enveja            ",
				"Sant Jaume de Frontany        ",
				"Sant Jaume de Llierca          ",
				"Sant Jaume dels Domenys        ",
				"Sant Joan Desp                ",
				"Sant Joan de Mollet            ",
				"Sant Joan de Vilatorrada       ",
				"Sant Joan de les Abadesses     ",
				"Sant Joan les Fonts            ",
				"Sant Jordi Desvalls            ",
				"Sant Juli de Cerdanyola       ",
				"Sant Juli de Ramis            ",
				"Sant Juli de Vilatorta        ",
				"Sant Juli del Llor i Bonmat  ",
				"Sant Just Desvern              ",
				"Sant Lloren Savall            ",
				"Sant Lloren d'Hortons         ",
				"Sant Lloren de Morunys        ",
				"Sant Lloren de la Muga        ",
				"Sant Mart Sarroca             ",
				"Sant Mart Sesgueioles         ",
				"Sant Mart Vell                ",
				"Sant Mart d'Albars            ",
				"Sant Mart de Centelles        ",
				"Sant Mart de Llmena          ",
				"Sant Mart de Riucorb          ",
				"Sant Mart de Tous             ",
				"Sant Mateu de Bages            ",
				"Sant Miquel de Campmajor       ",
				"Sant Miquel de Fluvi          ",
				"Sant Mori                      ",
				"Sant Pau de Segries           ",
				"Sant Pere Pescador             ",
				"Sant Pere Sallavinera          ",
				"Sant Pere de Ribes             ",
				"Sant Pere de Riudebitlles      ",
				"Sant Pere de Torell           ",
				"Sant Pere de Vilamajor         ",
				"Sant Pol de Mar                ",
				"Sant Quint de Mediona         ",
				"Sant Quirze Safaja             ",
				"Sant Quirze de Besora          ",
				"Sant Quirze del Valls         ",
				"Sant Ramon                     ",
				"Sant Sadurn d'Anoia           ",
				"Sant Sadurn d'Osormort        ",
				"Sant Salvador de Guardiola     ",
				"Sant Vicen de Castellet       ",
				"Sant Vicen de Montalt         ",
				"Sant Vicen de Torell         ",
				"Sant Vicen dels Horts         ",
				"Santa Brbara                  ",
				"Santa Ceclia de Voltreg      ",
				"Santa Coloma de Cervell       ",
				"Santa Coloma de Farners        ",
				"Santa Coloma de Gramenet       ",
				"Santa Coloma de Queralt        ",
				"Santa Cristina d'Aro           ",
				"Santa Eugnia de Berga         ",
				"Santa Eullia de Riuprimer     ",
				"Santa Eullia de Ronana       ",
				"Santa Fe del Peneds           ",
				"Santa Llogaia d'lguema        ",
				"Santa Margarida de Montbui     ",
				"Santa Margarida i els Monjos   ",
				"Santa Maria d'Ol              ",
				"Santa Maria de Besora          ",
				"Santa Maria de Corc           ",
				"Santa Maria de Martorelles     ",
				"Santa Maria de Merls          ",
				"Santa Maria de Miralles        ",
				"Santa Maria de Palautordera    ",
				"Santa Oliva                    ",
				"Santa Pau                      ",
				"Santa Perptua de Mogoda       ",
				"Santa Susanna                  ",
				"Santpedor                      ",
				"Sarral                         ",
				"Sarri de Ter                  ",
				"Sarroca de Bellera             ",
				"Sarroca de Lleida              ",
				"Saus                           ",
				"Savall del Comtat             ",
				"Secuita                        ",
				"Selva de Mar                   ",
				"Selva del Camp                 ",
				"Senan                          ",
				"Senterada                      ",
				"Sentiu de Si                  ",
				"Sentmenat                      ",
				"Seriny                        ",
				"Serra de Dar                  ",
				"Sers                          ",
				"Setcases                       ",
				"Seu d'Urgell                   ",
				"Seva                           ",
				"Snia                          ",
				"Sidamon                        ",
				"Sils                           ",
				"Sitges                         ",
				"Siurana                        ",
				"Sobremunt                      ",
				"Solers                        ",
				"Solivella                      ",
				"Solsona                        ",
				"Sora                           ",
				"Soriguera                      ",
				"Sort                           ",
				"Soses                          ",
				"Subirats                       ",
				"Sudanell                       ",
				"Sunyer                         ",
				"Susqueda                       ",
				"Sria                          ",
				"Tagamanent                     ",
				"Talamanca                      ",
				"Talarn                         ",
				"Talavera                       ",
				"Tallada d'Empord              ",
				"Taradell                       ",
				"Tarragona                      ",
				"Tarrs                         ",
				"Tarroja de Segarra             ",
				"Tavertet                       ",
				"Tavrnoles                     ",
				"Tei                           ",
				"Terrades                       ",
				"Terrassa                       ",
				"Trmens                        ",
				"Tiana                          ",
				"Tiurana                        ",
				"Tivenys                        ",
				"Tivissa                        ",
				"Trvia                         ",
				"Tona                           ",
				"Tordera                        ",
				"Torell                        ",
				"Torms                          ",
				"Tornabous                      ",
				"Torre de Cabdella              ",
				"Torre de Claramunt             ",
				"Torre de Fontaubella           ",
				"Torre de l'Espanyol            ",
				"Torre-serona                   ",
				"Torrebesses                    ",
				"Torredembarra                  ",
				"Torrefarrera                   ",
				"Torrefeta i florejacs          ",
				"Torregrossa                    ",
				"Torrelameu                     ",
				"Torrelavit                     ",
				"Torrelles de Foix              ",
				"Torrelles de Llobregat         ",
				"Torrent                        ",
				"Torres de Segre                ",
				"Torroella de Fluvi            ",
				"Torroella de Montgr           ",
				"Torroja del Priorat            ",
				"Tortell                       ",
				"Tortosa                        ",
				"Tor                           ",
				"Toses                          ",
				"Tossa de Mar                   ",
				"Tremp                          ",
				"Trrega                        ",
				"Ullastrell                     ",
				"Ullastret                      ",
				"Ulldecona                      ",
				"Ulldemolins                    ",
				"Ull                           ",
				"Ultramort                      ",
				"Urs                           ",
				"Vacarisses                     ",
				"Vajol                          ",
				"Vall d'en Bas                  ",
				"Vall de Bo                    ",
				"Vall de Bianya                 ",
				"Vall de Cards                 ",
				"Vall-llobrega                  ",
				"Vallbona d'Anoia               ",
				"Vallbona de les Monges         ",
				"Vallcebre                      ",
				"Vallclara                      ",
				"Vallfogona de Balaguer         ",
				"Vallfogona de Ripolls         ",
				"Vallfogona de Riucorb          ",
				"Vallgorguina                   ",
				"Vallirana                      ",
				"Vallmoll                       ",
				"Vallromanes                    ",
				"Valls                          ",
				"Valls d'Aguilar                ",
				"Valls de Valira                ",
				"Vandells i l'Hosp.de l'Infant ",
				"Vansa i Frnols                ",
				"Veciana                        ",
				"Vendrell                       ",
				"Ventall                       ",
				"Verd                          ",
				"Verges                         ",
				"Vespella de Gai               ",
				"Vic                            ",
				"Vidreres                       ",
				"Vidr                          ",
				"Vielha e Mijaran               ",
				"Vila-rodona                    ",
				"Vila-sacra                     ",
				"Vila-sana                      ",
				"Vila-seca                      ",
				"Vilabella                      ",
				"Vilabertran                    ",
				"Vilablareix                    ",
				"Vilada                         ",
				"Viladamat                      ",
				"Viladasens                     ",
				"Viladecans                     ",
				"Viladecavalls                  ",
				"Vilademuls                     ",
				"Viladrau                       ",
				"Vilafant                       ",
				"Vilafranca del Peneds         ",
				"Vilagrassa                     ",
				"Vilajuga                      ",
				"Vilalba Sasserra               ",
				"Vilalba dels Arcs              ",
				"Vilaller                       ",
				"Vilallonga de Ter              ",
				"Vilallonga del Camp            ",
				"Vilamacolum                    ",
				"Vilamalla                      ",
				"Vilamaniscle                   ",
				"Vilams                        ",
				"Vilanant                       ",
				"Vilanova d'Escornalbou         ",
				"Vilanova de Bellpuig           ",
				"Vilanova de Mei               ",
				"Vilanova de Prades             ",
				"Vilanova de Sau                ",
				"Vilanova de Segri             ",
				"Vilanova de l'Aguda            ",
				"Vilanova de la Barca           ",
				"Vilanova del Cam              ",
				"Vilanova del Valls            ",
				"Vilanova i la Geltr           ",
				"Vilaplana                      ",
				"Vilassar de Dalt               ",
				"Vilassar de Mar                ",
				"Vilaverd                       ",
				"Vilar                         ",
				"Vilella Alta                   ",
				"Vilella Baixa                  ",
				"Vilob d'Onyar                 ",
				"Vilob del Peneds             ",
				"Vilopriu                       ",
				"Vilosell                       ",
				"Vimbod                        ",
				"Vinaixa                        ",
				"Vinebre                        ",
				"Vinyols i els Arcs             ",
				"Viver i Serrateix              ",
				"Xerta                          "

			});

			/* Buttons */
			buttonSimple = new Button ();
			buttonSimple.Location = new Point (280, 30);
			buttonSimple.Text = "Simple";
			buttonSimple.Size = new Size (100, 23);
			buttonSimple.Click += new System.EventHandler (buttonSimpleClick);

			buttonDropDown = new Button ();
			buttonDropDown.Location = new Point (280, 80);
			buttonDropDown.Text = "DropList";
			buttonDropDown.Size = new Size (100, 23);
			buttonDropDown.Click += new System.EventHandler (buttonDropDownClick);

			buttonDropDownList = new Button ();
			buttonDropDownList.Location = new Point (280, 130);
			buttonDropDownList.Text = "DropDownList";
			buttonDropDownList.Size = new Size (100, 23);
			buttonDropDownList.Click += new System.EventHandler (buttonDropDownListClick);
					
			updownDropDownHeight = new NumericUpDown ();
			updownDropDownHeight.Location = new Point (280, 180);
			updownDropDownHeight.Size = new Size (100, 23);
			updownDropDownHeight.ValueChanged += new System.EventHandler (updownDropDownHeightValueChanged);
			updownDropDownHeight.Maximum = int.MaxValue;
			updownDropDownHeight.Value = comboBox.DropDownHeight;

			comboFlatStyle = new ComboBox ();
			comboFlatStyle.DropDownStyle = ComboBoxStyle.DropDownList;
			comboFlatStyle.Location = new Point (280, 230);
			comboFlatStyle.Size = new Size (100, 23);
			foreach (object obj in Enum.GetValues (typeof (FlatStyle))) {
				comboFlatStyle.Items.Add (obj);
			}
			comboFlatStyle.SelectedIndexChanged += new EventHandler (comboFlatStyleSelectedIndexChanged);

			comboDrawMode = new ComboBox ();
			comboDrawMode.DropDownStyle = ComboBoxStyle.DropDownList;
			comboDrawMode.Location = new Point (280, 280);
			comboDrawMode.Size = new Size (100, 23);
			foreach (object obj in Enum.GetValues (typeof (DrawMode))) {
				comboDrawMode.Items.Add (obj);
			}
			comboDrawMode.SelectedIndexChanged += new EventHandler (comboDrawModeSelectedIndexChanged);


			comboBox.Location = new System.Drawing.Point(8, 32);
			comboBox.Name = "comboBox";
			comboBox.Size = new System.Drawing.Size (248, 150);
			comboBox.TabIndex = 0;
			//comboBox.Text = "A normal ComboBox";
			comboBox.DropDownStyle = ComboBoxStyle.Simple;
			comboBox.MaxDropDownItems = 10;
			//comboBox.ItemHeight = false;
			
			buttonDropDownAction = new Button ();
			buttonDropDownAction.Location = new Point (400, 130);
			buttonDropDownAction.Text = "DropDown action";
			buttonDropDownAction.Size = new Size (100, 23);
			buttonDropDownAction.Click += new System.EventHandler (buttonDropDownListActionClick);
						
			
			buttonAddItems = new Button ();
			buttonAddItems.Location = new Point (400, 30);
			buttonAddItems.Text = "Add Items";
			buttonAddItems.Size = new Size (100, 23);
			buttonAddItems.Click += new System.EventHandler (buttonAddItemsClick);
			
			buttonCleanItems = new Button ();
			buttonCleanItems.Location = new Point (400, 80);
			buttonCleanItems.Text = "Clean Items";
			buttonCleanItems.Size = new Size (100, 23);
			buttonCleanItems.Click += new System.EventHandler (buttonCleanItemsClick);
					
			
			//this.comboBox.IntegralHeight = true;			
			//comboBox.Font = new System.Drawing.Font (comboBox.Font.FontFamily, comboBox.Font.Size + 5);
			
			
			// 
			// MainForm
			// 
			this.ClientSize = new System.Drawing.Size(624, 309);
			this.Controls.AddRange(new Control[] { buttonAddItems, buttonCleanItems,
						comboBox, buttonSimple, buttonDropDown, buttonDropDownList,
						buttonDropDownAction, updownDropDownHeight, comboFlatStyle, comboDrawMode});
						
			this.Text = "Single ComboBox sample";
			this.ResumeLayout(false);
			
			Console.WriteLine ("ComboBox Size {0}", comboBox.Size);
			Console.WriteLine ("ComboBox IntegralHeight {0}", comboBox.IntegralHeight);
			Console.WriteLine ("ComboBox ItemHeight {0}", comboBox.ItemHeight);
			Console.WriteLine ("ComboBox FontHeight {0}", comboBox.Font.Height);			
			Console.WriteLine ("ComboBox String {0}", comboBox.ToString ());		
			
		}
		
		private void comboDrawModeSelectedIndexChanged (object sender, System.EventArgs e)
		{
			try {
				comboBox.DrawMode = (DrawMode) comboDrawMode.SelectedItem;
			} catch (Exception ex) {
				MessageBox.Show (ex.Message);
			}
		}

		private void comboFlatStyleSelectedIndexChanged (object sender, System.EventArgs e)
		{
			try {
				comboBox.FlatStyle = (FlatStyle) comboFlatStyle.SelectedItem;
			} catch (Exception ex) {
				MessageBox.Show (ex.Message);
			}
		}

		private void updownDropDownHeightValueChanged (object sender, System.EventArgs e)
		{
			try {
				comboBox.DropDownHeight = (int) updownDropDownHeight.Value;
			} catch (Exception ex) {
				MessageBox.Show (ex.Message);
			}
		}

		
		private void buttonDropDownListActionClick (object sender, System.EventArgs e)
		{				
			comboBox.DroppedDown = !comboBox.DroppedDown;
		}	
		
		private void buttonCleanItemsClick (object sender, System.EventArgs e)
		{				
			comboBox.Items.Clear ();			
		}
		
		private void buttonAddItemsClick (object sender, System.EventArgs e)
		{				
			for (int i = 0; i < 8; i++) {
				comboBox.Items.Add ("Item " + last_item);
				last_item++;
			}
		}

		private void buttonSimpleClick (object sender, System.EventArgs e)
		{				
			comboBox.DropDownStyle = ComboBoxStyle.Simple;
		}

		private void buttonDropDownClick (object sender, System.EventArgs e)
		{
			comboBox.DropDownStyle = ComboBoxStyle.DropDown;
		}

		private void buttonDropDownListClick (object sender, System.EventArgs e)
		{
			comboBox.DropDownStyle = ComboBoxStyle.DropDownList;
		}
		
		public static void Main (string[] args)
		{
			Application.Run (new MainForm ());
		}
	}			
}
